
/*
 * reveal (c) 1999 by Mixter
 * part of the phantom sniffer distribution
 */

#ifndef CRYPT_3DES
#define CRYPT_3DES
#endif

#include "config.h"

extern int encrypt_3_way (word96, unsigned char *, word32);
extern int decrypt_3_way (word96, unsigned char *, word32);

#define BSIZE			(MAXIMUM_CAPTURE+32)

int
main (int argc, char **argv)
{
  FILE *in, *out;
  char tempie[128], buffer[BSIZE];
  word96 tsalt =
  {1, 1, 1}, salts =
  {0, 0, 0};
  int count = 0;

  if (argc != 2)
    {
      fprintf (stderr, "usage: %s <infile>\n", argv[0]);
      fflush (stderr);
      exit (0);
    }
  snprintf (tempie, 128, "%s.out", argv[1]);
  in = fopen (argv[1], "r");
  out = fopen (tempie, "a");
  if ((in == NULL) || (out == NULL))
    {
      fprintf (stderr, "Could not open logfiles!\n");
      fflush (stderr);
      exit (0);
    }

  bzero (tempie, sizeof (tempie));
  strncpy (tempie, getpass ("Password: "), 128);

  if (!tempie)
    {
      fprintf (stderr, "Invalid password.\n");
      fflush (stderr);
      exit (0);
    }

  while ((count < 128) && (tempie[count] != '\n') && (tempie[count] != '\0'))
    {
      tsalt[0] += tempie[count] * count;
      tsalt[1] += (tempie[1] << 2) * count;
      tsalt[2] *= tempie[count];
      count++;
    }

  count = 0;
  encrypt_3_way (tsalt, (word8 *) salts, 12);

  printf ("Decrypting, hold on... ");
  bzero (buffer, BSIZE);

  while (!feof (in))
    {
      buffer[count] = fgetc (in);
      if (count > 2 && buffer[count] == 'R' && buffer[count - 1] == 'O' && buffer[count - 2] == 'E')
	{
	  buffer[count - 2] = '\0';
	  buffer[count - 1] = '\0';
	  buffer[count] = '\0';
	  decrypt_3_way (salts, buffer, strlen (buffer));
	  fputs (buffer, out);
	  fflush (out);
	  count = 0;
	  bzero (buffer, BSIZE);
	  continue;
	}
      if (count++ > BSIZE)
	{
	  printf ("overflow!\nFile not encrypted, or wrong password!\n");
	  fflush (stdout);
	  exit (0);
	}
    }

  printf ("finished!\n");
  fflush (stdout);

  return 0;
}
